! Parent module defines the interface block
MODULE m_point

  TYPE :: point
     REAL :: x, y
  END TYPE point

  INTERFACE
     REAL MODULE FUNCTION point_dist(a, b)
       TYPE(point), INTENT(IN) :: a, b
     END FUNCTION point_dist
  END INTERFACE

END MODULE m_point

! The submodule part define the implementation
SUBMODULE (m_point) point_a

CONTAINS

  MODULE PROCEDURE point_dist
    point_dist = SQRT((a%x-b%x)**2 + (a%y-b%y)**2)
  END PROCEDURE point_dist

END SUBMODULE point_a
